
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class ProgramsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const programs = await db.programs.create(
            {
                id: data.id || undefined,
        
        program_name: data.program_name
        ||
        null
            ,
            
        program_type: data.program_type
        ||
        null
            ,
            
        description: data.description
        ||
        null
            ,
            
        is_published: data.is_published
        ||
        false
        
            ,
            
        published_at: data.published_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await programs.setOrganization(currentUser.organization.id || null, {
            transaction,
        });
        

        

        

        return programs;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const programsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                program_name: item.program_name
            ||
            null
            ,
            
                program_type: item.program_type
            ||
            null
            ,
            
                description: item.description
            ||
            null
            ,
            
                is_published: item.is_published
            ||
            false
        
            ,
            
                published_at: item.published_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const programs = await db.programs.bulkCreate(programsData, { transaction });

        // For each item created, replace relation files
        

        return programs;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const programs = await db.programs.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.program_name !== undefined) updatePayload.program_name = data.program_name;
        
        
        if (data.program_type !== undefined) updatePayload.program_type = data.program_type;
        
        
        if (data.description !== undefined) updatePayload.description = data.description;
        
        
        if (data.is_published !== undefined) updatePayload.is_published = data.is_published;
        
        
        if (data.published_at !== undefined) updatePayload.published_at = data.published_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await programs.update(updatePayload, {transaction});

        
        
        if (data.organization !== undefined) {
            await programs.setOrganization(
              
              (globalAccess ? data.organization : currentUser.organization.id),
              
              { transaction }
            );
        }
        

        
        

        

        return programs;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const programs = await db.programs.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of programs) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of programs) {
                await record.destroy({transaction});
            }
        });


        return programs;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const programs = await db.programs.findByPk(id, options);

        await programs.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await programs.destroy({
            transaction
        });

        return programs;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const programs = await db.programs.findOne(
            { where },
            { transaction },
        );

        if (!programs) {
            return programs;
        }

        const output = programs.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        output.learning_paths_program = await programs.getLearning_paths_program({
            transaction
        });
        
        
        
        output.checklists_program = await programs.getChecklists_program({
            transaction
        });
        
        
        
        output.enrollments_program = await programs.getEnrollments_program({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.organization = await programs.getOrganization({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.organizations,
        as: 'organization',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.program_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'programs',
                        'program_name',
                        filter.program_name,
                    ),
                };
            }
            
            if (filter.description) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'programs',
                        'description',
                        filter.description,
                    ),
                };
            }
            

            
            

            
            if (filter.published_atRange) {
                const [start, end] = filter.published_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    published_at: {
                    ...where.published_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    published_at: {
                    ...where.published_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.program_type) {
                where = {
                    ...where,
                program_type: filter.program_type,
            };
            }
            
            if (filter.is_published) {
                where = {
                    ...where,
                is_published: filter.is_published,
            };
            }
            


      
      if (filter.organization) {
        const listItems = filter.organization.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.programs.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'programs',
                        'program_name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.programs.findAll({
            attributes: [ 'id', 'program_name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['program_name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.program_name,
        }));
    }

    
};

